"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const octonom_1 = require("octonom");
function Timestamp(base) {
    const newClass = class extends base {
    };
    // ideally we'd use the decorators on the property as usual but
    // typescript doesn't like this yet, see
    // https://github.com/Microsoft/TypeScript/issues/7342
    octonom_1.Property.Date()(newClass.prototype, 'createdAt');
    octonom_1.Property.Date()(newClass.prototype, 'updatedAt');
    octonom_1.Hook('afterSet', ({ instance, data }) => {
        const date = new Date();
        if (!instance.createdAt) {
            instance.createdAt = date;
        }
        if (data.updatedAt === undefined) {
            instance.updatedAt = date;
        }
    })(newClass);
    return newClass;
}
exports.Timestamp = Timestamp;
//# sourceMappingURL=timestamp.js.map